<template>
  <v-dialog :value="value" @input="$emit('input')" scrollable max-width="500px" persistent>
    <v-card>
      <v-card-text class="pop">
        <st-title text="Registro de Alumnos"/>
        <v-sheet class="st-sheet" :color="colorFormat">
          {{ this.validation.format.msg || 'Se validará el formato de las cabeceras' }}
        </v-sheet>
        <v-sheet class="st-sheet" :color="colorEmpty">
          {{ this.validation.empty.msg  || 'Se validarán valores nulos en columnas obligatorias' }}
        </v-sheet>
        <v-sheet class="st-sheet" :color="colorRepeat">
          {{ this.validation.repeat.msg || 'Se validarán valores no repetidos en columnas con valores únicos' }}
        </v-sheet>
        <div class="my-5">
          <v-col md="12">
              <a class="download" :href="template">
                <v-row align="center">
                  <v-icon class="mx-1">mdi-cloud-download</v-icon>
                  Descargar plantilla
                  </v-row>
              </a>
          </v-col>
          <v-file-input
            label="Archivo excel con datos de los alumnos a registrar"
            accept="application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"
            @change="validateFile($event)"
          />
        </div>
        <div class="content-footer">
          <st-secondary-btn nombre="Cancelar" @click="$emit('cancel')"/>
          <st-primary-btn nombre = "Registrar alumnos" @click="registerStudents" :disable="!validated" :loading="loading"/>
        </div>
      </v-card-text>
    </v-card>
  </v-dialog>
</template>

<script>
  import excelParser from "../assets/js/excel/parser";
  import isExcel from "../assets/js/excel/helpers";
  import studentBulker from "../assets/js/bulk/student-bulker";
  import studentTemplate from "../assets/templates/plantilla_alumnos.xlsx";

  export default {
    name: "StudentBulkRegister",
    props: ['value'],
    data() { return {
      loading: false,
      students: [],
      template: studentTemplate,
      validation: { format: {}, empty: {}, repeat: {} },
      bulkStudents: [],
    }},
    computed: {
      validated: function () { return this.validation.format.ok && this.validation.empty.ok && this.validation.repeat.ok },
      colorFormat: function() { return this.validation.format.ok === null || this.validation.format.ok === undefined ? "#b5d5ff" : this.validation.format.ok ? "#99ffae" : "#ffadad" },
      colorEmpty : function() { return this.validation.empty.ok  === null || this.validation.empty.ok  === undefined ? "#b5d5ff" : this.validation.empty.ok  ? "#99ffae" : "#ffadad" },
      colorRepeat: function() { return this.validation.repeat.ok === null || this.validation.repeat.ok === undefined ? "#b5d5ff" : this.validation.repeat.ok ? "#99ffae" : "#ffadad" }
    },
    methods: {
      async validateFile(file) {
        if (!isExcel(file)) {
          this.validation.empty.ok = null;
          this.validation.format.ok = null;
          this.validation.repeat.ok = null;
          this.validation.empty.msg = null;
          this.validation.format.msg = null;
          this.validation.repeat.msg = null;
          return;
        }
        try {
          // lee el contenido de cada hoja dentro del excel, se toma solo el primero
          let content = await excelParser.importFile(file);
          this.validation.format = studentBulker.validateHeaders(content);
          this.validation.empty  = studentBulker.validateNoEmptyColumnValues(content);
          this.validation.repeat = studentBulker.validateNoRepeteatedValues(content);
          if (this.validation.format.ok && this.validation.empty.ok && this.validation.repeat.ok) {
            this.bulkStudents = studentBulker.deserialize(content)
          }
        } catch(error) {
          console.error(error)
          // this.$store.commit('setError', error)
        }
      },
      async registerStudents() {
        this.loading = true;
        try {
          let payload = {
            idUnidad: this.$store.state.role.idUnit,
            alumnos: this.bulkStudents,
          };
          let response = await this.$api.bulkStudents(payload);
          const noRegisteredCant = response.data.data.length;
          if (noRegisteredCant !== 0) studentBulker.downloadExcelNotRegistered2(response.data.data);
          this.$emit('refreshData',response)
        } catch(e) {
          console.error(e);
          this.$store.commit('setError', e)
        }
        this.loading = false;
      },
      downloadTemplate() {
        studentBulker.downloadTemplate();
      }
    }
  }
</script>

<style scoped>
.download{
  text-decoration: none;
  color:#444
}
.st-sheet{
  text-align: center;
  margin: 10px -24px -10px;
  padding:5px 24px;
}

</style>
